searchData={"items":[{"type":"module","title":"AshAutoCodeInterface","doc":"","ref":"AshAutoCodeInterface.html"},{"type":"macro","title":"AshAutoCodeInterface.auto_code_interface/1","doc":"","ref":"AshAutoCodeInterface.html#auto_code_interface/1"},{"type":"module","title":"AshAutoCodeInterface.Info","doc":"","ref":"AshAutoCodeInterface.Info.html"},{"type":"function","title":"AshAutoCodeInterface.Info.auto_code_interface_except/1","doc":"Actions to exclude from code_interface generation","ref":"AshAutoCodeInterface.Info.html#auto_code_interface_except/1"},{"type":"function","title":"AshAutoCodeInterface.Info.auto_code_interface_except!/1","doc":"Actions to exclude from code_interface generation","ref":"AshAutoCodeInterface.Info.html#auto_code_interface_except!/1"},{"type":"function","title":"AshAutoCodeInterface.Info.auto_code_interface_options/1","doc":"auto_code_interface DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshAutoCodeInterface.Info.html#auto_code_interface_options/1"},{"type":"module","title":"AshAutoCodeInterface.Transformer","doc":"","ref":"AshAutoCodeInterface.Transformer.html"},{"type":"function","title":"AshAutoCodeInterface.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshAutoCodeInterface.Transformer.html#after?/1"},{"type":"function","title":"AshAutoCodeInterface.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAutoCodeInterface.Transformer.html#after_compile?/0"},{"type":"function","title":"AshAutoCodeInterface.Transformer.before?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","ref":"AshAutoCodeInterface.Transformer.html#before?/1"},{"type":"function","title":"AshAutoCodeInterface.Transformer.transform/1","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","ref":"AshAutoCodeInterface.Transformer.html#transform/1"},{"type":"function","title":"AshAutoCodeInterface.Transformer.validate_except/3","doc":"","ref":"AshAutoCodeInterface.Transformer.html#validate_except/3"},{"type":"extras","title":"AshAutoCodeInterface","doc":"# AshAutoCodeInterface\n\nAutomatically generates code_interface for ash resources' actions.","ref":"readme.html"},{"type":"extras","title":"Installation - AshAutoCodeInterface","doc":"Add `ash_auto_code_interface` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_auto_code_interface, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshAutoCodeInterface","doc":"```elixir\ndefmodule Post do\n  use Ash.Resource, domain: Domain, data_layer: Ash.DataLayer.Ets, extensions: [AshAutoCodeInterface]\n\n  ets do\n    private? true\n  end\n\n  attributes do\n    uuid_primary_key :id\n\n    attribute :title, :string, allow_nil?: false, public?: true\n    attribute :tag, :string, allow_nil?: true, public?: true\n  end\n\n  actions do\n    defaults [:read, :destroy, create: :*, update: :*]\n\n    read :get do\n      get_by :id\n    end\n  end\n\n  code_interface do\n    define :create, args: [:title, :tag]\n  end\n\n  auto_code_interface do\n    except [:destroy]\n  end\nend\n\n# Defined by code_interface\n post = Post.create!(\"Hello\", \"greeting\")\n\n# Defined by auto_code_interface\n assert %{title: \"Hello\", tag: \"greeting\"} = Post.get!(%{id: post.id})\n assert [%{title: \"Hello\", tag: \"greeting\"}] = Post.read!()\n```","ref":"readme.html#usage"},{"type":"extras","title":"License - AshAutoCodeInterface","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}